/*
 * Copyright Staffan Gimåker 2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_VERSION_HH_INCLUDED
#define PEEKABOT_VERSION_HH_INCLUDED


#include <string>
#include <boost/cstdint.hpp>


namespace peekabot
{
    extern const boost::uint8_t     PEEKABOT_VERSION_MAJOR;
    extern const boost::uint8_t     PEEKABOT_VERSION_MINOR;
    extern const boost::uint8_t     PEEKABOT_VERSION_REVISION;
    extern const boost::uint32_t    PEEKABOT_VERSION;
    extern const std::string        PEEKABOT_VERSION_STRING;

    extern const boost::uint8_t     PEEKABOT_RELEASE_STATUS;

    extern const boost::uint8_t     PEEKABOT_COMPATIBLE_VERSION_MAJOR;
    extern const boost::uint8_t     PEEKABOT_COMPATIBLE_VERSION_MINOR;
    extern const boost::uint8_t     PEEKABOT_COMPATIBLE_VERSION_REVISION;
    extern const boost::uint32_t    PEEKABOT_COMPATIBLE_VERSION;
    extern const std::string        PEEKABOT_COMPATIBLE_VERSION_STRING;

    std::string make_peekabot_version_string(
        boost::uint8_t major,
        boost::uint8_t minor,
        boost::uint8_t rev,
        boost::uint8_t rc);
}


#endif // PEEKABOT_VERSION_HH_INCLUDED
