/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_SELECTED_HH_INCLUDED
#define PEEKABOT_SET_SELECTED_HH_INCLUDED


#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetSelected : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetSelected(ObjectID target, bool select) throw();

        virtual ~SetSelected() throw() {}

        virtual Action *clone() const;

        virtual void execute(ServerExecutionContext *context) const;

    private:
        SetSelected() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target;
        bool m_select;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 88


#endif // PEEKABOT_SET_SELECTED_HH_INCLUDED
