/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_API_CAMERA_PROXY_HH_INCLUDED
#define PEEKABOT_RENDERER_API_CAMERA_PROXY_HH_INCLUDED


#include "ObjectEntityProxy.hh"


namespace peekabot
{
    namespace renderer
    {
        namespace api
        {
            class CameraProxy : public ObjectEntityProxy
            {
            public:
                CameraProxy(Renderer &renderer);

                void set_fov(float fov);

                void set_zoom_distance(float zoom_distance);

                void set_orthographic(bool orthographic);

                void set_near_plane(float near);

                void set_far_plane(float far);
            };
        }
    }
}


#endif // PEEKABOT_RENDERER_API_CAMERA_PROXY_HH_INCLUDED
