/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_API_ENTITY_PROXY_HH_INCLUDED
#define PEEKABOT_RENDERER_API_ENTITY_PROXY_HH_INCLUDED


#include <boost/utility.hpp>

#include "../Types.hh"


namespace peekabot
{
    namespace renderer
    {
        class SceneAction;

        namespace api
        {
            class Renderer;

            class EntityProxy : public boost::noncopyable
            {
            public:
                virtual ~EntityProxy();

                EntityID entity_id() const;

            protected:
                EntityProxy(Renderer &renderer);

                void dispatch(SceneAction *action);

            private:
                static EntityID allocate_entity_id() throw();

            private:
                Renderer &m_renderer;

                const EntityID m_entity_id;
            };
        }
    }
}


#endif // PEEKABOT_RENDERER_API_ENTITY_PROXY_HH_INCLUDED
