/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_API_OBJECT_ENTITYPROXY_HH_INCLUDED
#define PEEKABOT_RENDERER_API_OBJECT_ENTITYPROXY_HH_INCLUDED


#include "EntityProxy.hh"
#include "../../Matrix.hh"


namespace peekabot
{
    namespace renderer
    {
        class SceneAction;

        namespace api
        {
            class Renderer;

            class ObjectEntityProxy : public EntityProxy
            {
            public:
                void set_transformation(const Matrix4f &mtow);

                void set_color(const RGBColor &color);

                void set_opacity(float alpha);

                void set_layer(uint32_t layer);

                void set_name(uint32_t name);

                void set_visibility(bool visible);

                void set_selected(bool is_selected);

                void set_has_selected_ancestor(bool has_selected_ancestor);

                void set_parent(EntityID parent_id);

                void set_parent(const ObjectEntityProxy &e);

            protected:
                ObjectEntityProxy(Renderer &renderer);
            };
        }
    }
}


#endif // PEEKABOT_RENDERER_API_OBJECT_ENTITYPROXY_HH_INCLUDED
