/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_API_OCCUPANCY_GRID_2D_PROXY_HH_INCLUDED
#define PEEKABOT_RENDERER_API_OCCUPANCY_GRID_2D_PROXY_HH_INCLUDED


#include <vector>

#include "../../Vector.hh"
#include "../../Types.hh"
#include "ObjectEntityProxy.hh"


namespace peekabot
{
    namespace renderer
    {
        namespace api
        {
            class OccupancyGrid2DProxy : public ObjectEntityProxy
            {
            public:
                OccupancyGrid2DProxy(
                    Renderer &renderer,
                    float cell_size,
                    const RGBColor &unoccupied_color,
                    const RGBColor &occupied_color);

                void set_cells(
                    const std::vector<std::pair<Vector2f, float> > &cells);
            };
        }
    }
}


#endif // PEEKABOT_RENDERER_API_OCCUPANCY_GRID_2D_PROXY_HH_INCLUDED
