/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "PolygonProxy.hh"
#include "../SceneAction.hh"
#include "../Scene.hh"
#include "../entities/Polygon.hh"


using namespace peekabot;
using namespace peekabot::renderer;
using namespace peekabot::renderer::api;


PolygonProxy::PolygonProxy(Renderer &renderer)
    : ObjectEntityProxy(renderer),
      VertexBasedProxy(renderer)
{
    class AddPolygon : public SceneAction
    {
    public:
        AddPolygon(EntityID id) : m_id(id) {}

        virtual void execute(SceneAction::Context &context)
        {
            Entity *e = new Polygon();

            try
            {
                context.scene().add_entity(m_id, e);
            }
            catch(...)
            {
                delete e;
                throw;
            }
        }

    private:
        const EntityID m_id;
    };

    dispatch(new AddPolygon(entity_id()));
}
