/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "VertexBasedProxy.hh"
#include "../SceneAction.hh"
#include "../Scene.hh"
#include "../VertexBased.hh"
#include "../Entity.hh"


using namespace peekabot;
using namespace peekabot::renderer;
using namespace peekabot::renderer::api;


VertexBasedProxy::VertexBasedProxy(Renderer &renderer)
    : ObjectEntityProxy(renderer)
{
}


void VertexBasedProxy::set_vertices(const Vertices &verts)
{
    class SetVertices : public SceneAction
    {
    public:
        SetVertices(EntityID id, const Vertices &verts)
            : m_id(id), m_verts(verts) {}

        virtual void execute(SceneAction::Context &context)
        {
            context.scene().get_entity<VertexBased>(
                m_id)->set_vertices(m_verts);
        }

    private:
        const EntityID m_id;
        const Vertices m_verts;
    };

    dispatch(new SetVertices(entity_id(), verts));
}
