/*
 * Copyright Staffan Gimåker 2007-2008.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH_INCLUDED
#define PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH_INCLUDED


#include "../VertexBased.hh"
#include "../CullableEntity.hh"
#include "../Mesh.hh"


namespace peekabot
{
    namespace renderer
    {
        class Polygon : public CullableEntity,
                        public VertexBased
        {
        public:
            Polygon();

            Polygon(const Polygon &x);

            //virtual Polygon *clone() const throw();

            virtual void get_renderables(PrepareRenderContext &context) const;

            virtual void set_vertices(const VertexBased::Vertices &vertices) throw();

            virtual void add_vertices(const VertexBased::Vertices &vertices) throw();

            virtual void get_vertices(VertexBased::Vertices &vertices) const throw();

        protected:
            void calculate_bvs(const VertexBased::Vertices &vertices) throw();

        private:
            TriMesh m_mesh;
        };
    }
}


#endif // PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH_INCLUDED
